VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Dlg_Browse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Thomas Geiger

'-----------------------------'
' Dlg_Browse - Version 1.00   '
' Written by Thomas Geiger    '
'-----------------------------'

'Unsere internen Variablen
Private tHwndOwner As Long
Private tText As String
Private tFolderName As String
Private tCancelError As Boolean
Private tBrowseIn As BrowseFolders

'API Deklarationen
Private Declare Function SHGetPathFromIDList Lib _
                "shell32.dll" Alias "SHGetPathFromIDListA" _
                (ByVal pidl As Long, ByVal pszPath As String) _
                As Long

Private Declare Function SHGetSpecialFolderLocation Lib _
                "shell32.dll" (ByVal HwndOwner As Long, _
                ByVal nFolder As Long, pidl As ITEMIDLIST) _
                As Long

Private Declare Function SHBrowseForFolder Lib "shell32.dll" _
                Alias "SHBrowseForFolderA" (lpBrowseInfo As _
                BROWSEINFO) As Long 'ITEMIDLIST


'Typen, die wir brauchen
Private Type SHITEMID
    cb As Long
    abID As Byte
End Type
Private Type ITEMIDLIST
    mkid As SHITEMID
End Type
Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type
Public Enum BrowseFolders
  BF_STANDART
  BF_DESKTOP
  BF_PROGRAMS
  BF_CONTROLS
  BF_PRINTERS
  BF_PERSONAL
  BF_FAVORITES
  BF_STARTUP
  BF_RECENT
  BF_SENDTO
  BF_BITBUCKET
  BF_STARTMENU
  BF_DESKTOPDIRECTORY
  BF_DRIVES
  BF_NETWORK
  BF_NETHOOD
  BF_FONTS
  BF_TEMPLATES
End Enum

'Und jetzt brauchen wir noch mehrere Konstanten
Private Const NOERROR = 0
Private Const CSIDL_DESKTOP = &H0
Private Const CSIDL_PROGRAMS = &H2
Private Const CSIDL_CONTROLS = &H3
Private Const CSIDL_PRINTERS = &H4
Private Const CSIDL_PERSONAL = &H5
Private Const CSIDL_FAVORITES = &H6
Private Const CSIDL_STARTUP = &H7
Private Const CSIDL_RECENT = &H8
Private Const CSIDL_SENDTO = &H9
Private Const CSIDL_BITBUCKET = &HA
Private Const CSIDL_STARTMENU = &HB
Private Const CSIDL_DESKTOPDIRECTORY = &H10
Private Const CSIDL_DRIVES = &H11
Private Const CSIDL_NETWORK = &H12
Private Const CSIDL_NETHOOD = &H13
Private Const CSIDL_FONTS = &H14
Private Const CSIDL_TEMPLATES = &H15
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000
Private Const CLSCD_ERRNUMUSRCANCEL = 32755
Private Const CLSCD_ERRDESUSRCANCEL = "www.visualbasicworld.de - Version 1.00: Abbrechen wurde angeklickt"
Public Function ShowBrowse()

'============================================='
'Die Hauptfunktion, die das Dialogfeld anzeigt'
'============================================='

   'Variablen deklarieren
   Dim bi As BROWSEINFO
   Dim idl As ITEMIDLIST
   Dim rtn&, pidl&, path$, pos%
   
      'Strukturen erstellen und fllen
      bi.hOwner = tHwndOwner
      bi.lpszTitle = tText
      
      'Jetzt mssen wir festlegen, wonach wir suchen wollen
      Select Case tBrowseIn
      Case BF_STANDART
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_DESKTOP
        bi.pidlRoot = CSIDL_DESKTOP
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_PROGRAMS
        bi.pidlRoot = CSIDL_PROGRAMS
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_CONTROLS
        bi.pidlRoot = CSIDL_CONTROLS
        bi.ulFlags = BIF_BROWSEFORPRINTER
      Case BF_PRINTERS
        bi.pidlRoot = CSIDL_PRINTERS
        bi.ulFlags = BIF_BROWSEFORPRINTER
      Case BF_PERSONAL
        bi.pidlRoot = CSIDL_PERSONAL
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_FAVORITES
        bi.pidlRoot = CSIDL_FAVORITES
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_STARTUP
        bi.pidlRoot = CSIDL_STARTUP
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_RECENT
        bi.pidlRoot = CSIDL_RECENT
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_SENDTO
        bi.pidlRoot = CSIDL_SENDTO
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_BITBUCKET
        bi.pidlRoot = CSIDL_BITBUCKET
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_STARTMENU
        bi.pidlRoot = CSIDL_STARTMENU
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_DESKTOPDIRECTORY
        bi.pidlRoot = CSIDL_DESKTOPDIRECTORY
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_DRIVES
        bi.pidlRoot = CSIDL_DRIVES
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_NETWORK
        bi.pidlRoot = CSIDL_NETWORK
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_NETHOOD
        bi.pidlRoot = CSIDL_NETHOOD
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      Case BF_FONTS
        bi.pidlRoot = CSIDL_FONTS
        bi.ulFlags = BIF_BROWSEFORPRINTER
      Case BF_TEMPLATES
        bi.pidlRoot = CSIDL_TEMPLATES
        bi.ulFlags = BIF_RETURNONLYFSDIRS
      End Select
      
      'Jetzt holen wir uns den Pfad, falls dies mglich ist
      pidl& = SHBrowseForFolder(bi)
      path$ = Space$(512)
      rtn& = SHGetPathFromIDList(ByVal pidl&, ByVal path$)
      
      'Und zum Schluss analysieren wir noch die Rckgabe
      If rtn& Then
      pos% = InStr(path$, Chr$(0))
      tFolderName = Left(path$, pos - 1)
      Else
        If CancelError = True Then
        Err.Raise Number:=CLSCD_ERRNUMUSRCANCEL, Description:=CLSCD_ERRDESUSRCANCEL
        End If
      Exit Function
      End If

End Function

'============================'
'Eigenschaften unserer Klasse'
'============================'

Public Property Get HwndOwner() As Long

   HwndOwner = tHwndOwner
   
End Property
Public Property Let HwndOwner(ByVal vNewValue As Long)

   tHwndOwner = vNewValue
   
End Property
Public Property Get Text() As String

   Text = tText
   
End Property
Public Property Let Text(ByVal vNewValue As String)
   
   tText = vNewValue
   
End Property
Public Property Get FolderName() As String
   
   FolderName = tFolderName
   
End Property
Public Property Get CancelError() As Boolean
   
   CancelError = tCancelError
   
End Property
Public Property Let CancelError(ByVal vNewValue As Boolean)
   
   tCancelError = vNewValue
   
End Property
Public Property Get BrowseIn() As BrowseFolders
   
   BrowseIn = tBrowseIn
   
End Property
Public Property Let BrowseIn(ByVal vNewValue As BrowseFolders)
   
   tBrowseIn = vNewValue
   
End Property
