VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Dlg_FileSave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Thomas Geiger

'-------------------------------'
' Dlg_FileSave - Version 1.00   '
' Written by Thomas Geiger      '
'-------------------------------'

'Unsere internen Variablen
Private tFilter As String
Private tDialogTitle As String
Private tCancelError As Boolean
Private tDefaultDirectory As String
Private tFlags As Long
Private tFileName As String
Private tFileTitle As String
Private tHwndOwner As Long

'Windows Api Deklarationen
Private Declare Function GetSaveFileNameA Lib _
                "comdlg32.dll" (pOpenfilename _
                As tOPENFILENAME) As Long

Private Declare Function CommDlgExtendedError _
                Lib "comdlg32.dll" () As Long

'Konstanten fr die Dialogfelder
Private Const CLSCD_NOACTION = 0
Private Const CLSCD_SHOWOPEN = 1
Private Const CLSCD_SHOWSAVE = 2
Private Const CLSCD_USERCANCELED = 0
Private Const CLSCD_USERSELECTED = 1
Private Const CLSCD_MAXFILESIZE = 256
Private Const CLSCD_ERRNUMUSRCANCEL = 32755
Private Const CLSCD_ERRDESUSRCANCEL = "www.visualbasicworld.de - Version 1.00: Abbrechen wurde angeklickt"
Private Const CLSCD_ERRNUMUSRBUFFER = 32756
Private Const CLSCD_ERRDESUSRBUFFER = "www.visualbasicworld.de - Version 1.00: Puffer zu klein"
Private Const FNERR_BUFFERTOOSMALL = &H3003
Private Const FNERR_FILENAMECODES = &H3000
Private Const FNERR_INVALIDFILENAME = &H3002
Private Const FNERR_SUBCLASSFAILURE = &H3001

'Benutzerdefinierte Typen und Enum Typen
Private Type tOPENFILENAME
        lStructSize As Long
        HwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        Flags As DlgFileFlags
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Private Enum DlgFileFlags
   OFN_ALLOWMULTISELECT = &H200
   OFN_CREATEPROMPT = &H2000 = &H80
   OFN_EXPLORER = &H80000
   OFN_EXTENSIONDIFFERENT = &H400
   OFN_FILEMUSTEXIST = &H1000
   OFN_HIDEREADONLY = &H4
   OFN_LONGNAMES = &H200000
   OFN_NOCHANGEDIR = &H8
   OFN_NODEREFERENCELINKS = &H100000
   OFN_NOLONGNAMES = &H40000
   OFN_NONETWORKBUTTON = &H20000
   OFN_NOREADONLYRETURN = &H8000
   OFN_NOTESTFILECREATE = &H10000
   OFN_NOVALIDATE = &H100
   OFN_OVERWRITEPROMPT = &H2
   OFN_PATHMUSTEXIST = &H800
   OFN_READONLY = &H1
   OFN_SHOWHELP = &H10
End Enum
Public Function ShowSave()

'=========================================='
'Die Hauptfunktion, die den Dialog anzeigt.'
'=========================================='
   
   'Variablen deklarieren
   Dim OpenVar As tOPENFILENAME
   Dim ApiReturnValue As Long
   Dim lExtendedError As Long
   
      'Wir fllen die DialogStruktur
      OpenVar.lpstrTitle = tDialogTitle
      OpenVar.HwndOwner = tHwndOwner
        If tFilter <> "" Then
        OpenVar.lpstrFilter = sAPIFilter(tFilter)
        End If
      OpenVar.lpstrInitialDir = tDefaultDirectory
      OpenVar.Flags = tFlags
      OpenVar.lpstrDefExt = ".X"
      
      'Wir erweitern die Werte der Struktur
      OpenVar.nMaxFileTitle = CLSCD_MAXFILESIZE
      OpenVar.nMaxFile = CLSCD_MAXFILESIZE
      OpenVar.lpstrFileTitle = Space(CLSCD_MAXFILESIZE - 1) & vbNullChar
      OpenVar.lpstrFile = Space(CLSCD_MAXFILESIZE - Len("") - 1) & vbNullChar
      
      'Gre der Struktur eintragen
      OpenVar.lStructSize = Len(OpenVar)
      
      'Jetzt knnen wir die Standartfehlerbehebung starten
      On Error GoTo UnknownError
      
      'Und nun kommt der entscheidende Moment... wir zeigen das Dialogfeld
      ApiReturnValue = GetSaveFileNameA(OpenVar)
      
      'Nachdem das Dialogfeld gezeigt wurde, knnen wir den Rckgabewert und die Fehlermeldungen analysieren
        If ApiReturnValue = CLSCD_USERSELECTED Then
        tFileName = sLeftOfNull(OpenVar.lpstrFile)
        tFileTitle = sLeftOfNull(OpenVar.lpstrFileTitle)
        Else
        lExtendedError = CommDlgExtendedError
          If lExtendedError = FNERR_BUFFERTOOSMALL Then
          On Error GoTo 0
          Err.Raise Number:=CLSCD_ERRNUMUSRBUFFER, Description:=CLSCD_ERRDESUSRBUFFER
          Exit Function
          Else
            If tCancelError = True Then
            On Error GoTo 0
            Err.Raise Number:=CLSCD_ERRNUMUSRCANCEL, Description:=CLSCD_ERRDESUSRCANCEL
            Exit Function
            End If
          End If
        End If
      Exit Function
      
UnknownError:

End Function
Private Function sAPIFilter(ByVal Filter As String) As String

'====================================='
'Private Funktionen, die wir brauchen.'
'====================================='

   Dim I As Long
   Dim C As String * 1
   Dim NullFilter As String
   
   For I = 1 To Len(Filter)
      C = Mid(Filter, I, 1)
      If C = "|" Then
         NullFilter = NullFilter & Chr(0)
         Else
         NullFilter = NullFilter & C
         End If
   Next I
   
   While Right(NullFilter, 2) <> Chr(0) & Chr(0)
      NullFilter = NullFilter & Chr(0)
   Wend
   
      sAPIFilter = NullFilter
   
End Function
Private Function sLeftOfNull(ByVal txt As String)

   Dim I As Long, P As Long
   Dim ntxt As String, k As String * 1

   P = InStr(txt, Chr(0) & Chr(0))
   If P > 0 Then
      For I = 1 To P - 1
         k = Mid(txt, I, 1)
         If k = Chr(0) Then ntxt = ntxt & " " Else ntxt = ntxt & k
      Next I
      Else
      ntxt = Left(txt, InStr(txt, Chr(0)) - 1)
      End If
   sLeftOfNull = ntxt
   
End Function

'============================'
'Eigenschaften unserer Klasse'
'============================'

Public Property Get DialogTitle() As String

   DialogTitle = tDialogTitle

End Property
Public Property Let DialogTitle(ByVal vNewValue As String)
   
   tDialogTitle = vNewValue
   
End Property
Public Property Get Filter() As String
   
   Filter = tFilter
   
End Property
Public Property Let Filter(ByVal vNewValue As String)
   
   tFilter = vNewValue
   
End Property
Public Property Get CancelError() As Boolean

   CancelError = tCancelError
   
End Property
Public Property Let CancelError(ByVal vNewValue As Boolean)

   tCancelError = vNewValue
   
End Property
Public Property Get DefaultDirectory() As String
   
   DefaultDirectory = tDefaultDirectory

End Property
Public Property Let DefaultDirectory(ByVal vNewValue As String)
   
   tDefaultDirectory = vNewValue
   
End Property
Public Property Get Flags() As Long

   Flags = tFlags
   
End Property
Public Property Let Flags(ByVal vNewValue As Long)

   tFlags = vNewValue
   
End Property
Public Property Get HwndOwner() As Long

   HwndOwner = tHwndOwner
   
End Property
Public Property Let HwndOwner(ByVal vNewValue As Long)

   tHwndOwner = vNewValue
   
End Property
Public Property Get FileName() As String

   FileName = tFileName
   
End Property
Public Property Get FileTitle() As String

   FileTitle = tFileTitle
   
End Property

